<?php
if (!defined('_PS_VERSION_'))
  exit;
 
class LO extends Module
{
    public function __construct()
    {
    $this->name = 'lo';
    if (constant('_PS_VERSION_') >= 1.4)
        $this->tab = 'shipping_logistics';
    else
        $this->tab = 'Tools';

    $this->version = '1.0';
    $this->author = 'Livrari Online';
    $this->need_instance = 1;
    $this->context = Context::getContext();

    parent::__construct();

    $this->displayName = $this->l('Livrari Online');
    $this->description = $this->l('Modul integrare Livrari Online.');

    $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');

    // if (!Configuration::get('lo'))       
    //     $this->warning = $this->l('No name provided');

    // if (_PS_VERSION_ < '1.5')
    //     require(_PS_MODULE_DIR_.$this->name.'/backward_compatibility/backward.php');
    }

    public function install()
    {
        if (!parent::install() OR
            !$this->installDB())
            return false;
        return true;
    }

    public function installDB()
    {
        // Creation of the tables in a database
        $result = true;
        $queries = array();
        
        $queries[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'lo` (
            `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
            `id_order` INT UNSIGNED NOT NULL,
            `awb` varchar(500) NOT NULL,
            `date_add` DATETIME NOT NULL,
            `serviciu` varchar(500) NOT NULL,
            PRIMARY KEY (`id`)
        ) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';

        foreach ($queries as $query) {
            $result &= Db::getInstance()->Execute($query);
        }

        if (!$result)
            return false;
        
        return true;
    }

    public function uninstall()
    {
        Configuration::deleteByName('LO_LOGINID');
        Configuration::deleteByName('LO_KEY');
        Configuration::deleteByName('LO_SERVICIUID');
        Configuration::deleteByName('LO_STATUS');
        Configuration::deleteByName('LO_SHIPPINGCOMPANYID');
        Configuration::deleteByName('CUSTOMIZABLE_FIELDS');
        Configuration::deleteByName('NATIONAL_FIELDS');
        
        $result = Db::getInstance()->Execute('
            DROP TABLE IF EXISTS `'._DB_PREFIX_.'lo`
        ');
        return parent::uninstall();
    }

    public function getContent()
    {
        $this->_html = '';

        if (Tools::isSubmit('submitLO'))
        {
            if (Tools::getValue('LO_LOGINID') && Tools::getValue('LO_KEY') && Tools::getValue('LO_STATUS'))
            {
                Configuration::updateValue('LO_LOGINID', Tools::getValue('LO_LOGINID'));
                Configuration::updateValue('LO_KEY', Tools::getValue('LO_KEY'));
                Configuration::updateValue('LO_SERVICIUID', Tools::getValue('LO_SERVICIUID'));
                Configuration::updateValue('LO_STATUS', Tools::getValue('LO_STATUS'));
                Configuration::updateValue('LO_SHIPPINGCOMPANYID', Tools::getValue('LO_SHIPPINGCOMPANYID'));
                
                $this->_html .= $this->displayConfirmation($this->l('Configurare cu succes'));
            }
            else
                $this->_html .= $this->displayError($this->l('Completati toate campurile'));

        }
        elseif (Tools::isSubmit('submitCustomizableFeilds'))
        {
            $customizable_field_serviciu = Tools::getValue('customizable_field_serviciu');
            $customizable_field_judet = Tools::getValue('customizable_field_judet');
            $customizable_field_serviciuid = Tools::getValue('customizable_field_serviciuid');
            $customizable_field_shippingcompanyid = Tools::getValue('customizable_field_shippingcompanyid');
            $customizable_field_pret = Tools::getValue('customizable_field_pret');
            
            $customizable_string = '';
            foreach ($customizable_field_judet as $key => $value)
            {
                if (!$customizable_field_serviciu[$key] || !$customizable_field_judet[$key] || !$customizable_field_serviciuid[$key] || !$customizable_field_shippingcompanyid[$key])
                    continue;
                
                if ($customizable_string)
                    $customizable_string .= '¤';
                
                $customizable_string .= $customizable_field_serviciu[$key].'|'.$customizable_field_judet[$key].'|'.$customizable_field_serviciuid[$key].'|'.$customizable_field_shippingcompanyid[$key].'|'.$customizable_field_pret[$key];
            }   
            
            Configuration::updateValue('CUSTOMIZABLE_FIELDS', $customizable_string);
        }

        elseif (Tools::isSubmit('submitLONational'))
        {
            $national_field_serviciu = Tools::getValue('national_field_serviciu');
            $national_field_serviciuid = Tools::getValue('national_field_serviciuid');
            $national_field_shippingcompanyid = Tools::getValue('national_field_shippingcompanyid');
            $national_field_pret = Tools::getValue('national_field_pret');
            
            $national_string = '';
            foreach ($national_field_serviciu as $key => $value)
            {
                if (!$national_field_serviciu[$key] || !$national_field_serviciuid[$key] || !$national_field_shippingcompanyid[$key])
                    continue;
                
                if ($national_string)
                    $national_string .= '¤';
                
                $national_string .= $national_field_serviciu[$key].'|'.$national_field_serviciuid[$key].'|'.$national_field_shippingcompanyid[$key].'|'.$national_field_pret[$key];
            }   
            Configuration::updateValue('NATIONAL_FIELDS', $national_string);
        }

        $order_states = OrderState::getOrderStates((int)$this->context->cookie->id_lang);

        $this->_html .= $this->displayForm($order_states);

        return $this->_html;
    }

    public function displayForm($order_states)
    {
        $states = new State();
        $judete = $states->getStatesByIdCountry(36);

        $jud='<select name="customizable_field_judet[]">';
        foreach ($judete as $j) {
            $jud.='<option value="'.$j['id_state'].'">'.$j['name'].'</option>';
        }
        $jud.='</select>';

        $customizable_fields = array();
        if (Configuration::get('CUSTOMIZABLE_FIELDS'))
            foreach (explode('¤', Configuration::get('CUSTOMIZABLE_FIELDS')) as $customizable_field)
                $customizable_fields[] = explode('|', $customizable_field);

        $national_fields = array();
        if (Configuration::get('NATIONAL_FIELDS'))
            foreach (explode('¤', Configuration::get('NATIONAL_FIELDS')) as $national_field)
                $national_fields[] = explode('|', $national_field);

        $this->context->smarty->assign(array(
            'module_path' => $this->_path,
            'order_states' => $order_states,
            'judete' => $jud,
            'judete2' => $judete,
            'customizable_fields' => $customizable_fields,
            'national_fields' => $national_fields,
            'LO_LOGINID' => Tools::safeOutput(Configuration::get('LO_LOGINID')),
            'LO_KEY' => Tools::safeOutput(Configuration::get('LO_KEY')),
            'LO_STATUS' => (int)Tools::safeOutput(Configuration::get('LO_STATUS'))
        ));

        return $this->display(__FILE__, 'views/templates/admin/lo.tpl');
    }
}
?>